<!-- HTML header for doxygen 1.8.18-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=9" />
    <meta name="generator" content="Doxygen 1.9.1" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <title>VizBlocks: src/VizBlocks.h Source File</title>
    <link href="tabs.css" rel="stylesheet" type="text/css" />
    <script type="text/javascript" src="jquery.js"></script>
    <script type="text/javascript" src="dynsections.js"></script>
     <link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
    <link href="my_customdoxygen.css" rel="stylesheet" type="text/css" />
  </head>
  <body>
    <div id="top">
      <!-- do not remove this div, it is closed by doxygen! -->
      <header id="header" class="desktop">
        <div>
          <div class="inner-header">
            <div class="logotype">
              <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/" aria-hidden="true" title="Site home"
                >VizBlocks</a
              >
            </div>
            <div class="navigation">
              <button
                onclick="toggleBurger()"
                type="button"
                aria-label="toggle burger menu"
              >
                <i class="fa fa-bars"></i>
              </button>
              <nav id="menu" class="collapse">
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/" class="home">Home</a>
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/about" class="about">About</a>
                <a
                  href="https://edinburgh-college-of-art.github.io/vizblocks-website/tutorials/0_getting_started.html"
                  class="start"
                  >Get Started</a
                >
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/tutorials" class="tutorials"
                  >Tutorials</a
                >
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/docs/html" class="docs"
                  >Technical Info</a
                >
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/contact" class="content">Contact</a>
              </nav>
            </div>
          </div>
        </div>
        <script>
          const toggleBurger = () => {
            const menu = document.getElementById("menu");
            if (menu.className === "collapse") {
              menu.className = "extend";
            } else {
              menu.className = "collapse";
            }
          };
          const touchDevice = "ontouchstart" in document.documentElement;
          if (touchDevice) {
            const header = document.getElementById("header");
            header.className = "mobile";
          }
        </script>
      </header>
      <!-- end header part -->
    </div>
  </body>
</html>
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">VizBlocks.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_viz_blocks_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef VizBlock_H</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define VizBlock_H</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#include &lt;Arduino.h&gt;</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_behaviours_8h.html">Behaviours.h</a>&quot;</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_name_dictionary_8h.html">NameDictionary.h</a>&quot;</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_servo_behaviours_8h.html">ServoBehaviours.h</a>&quot;</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_l_e_d_behaviours_8h.html">LEDBehaviours.h</a>&quot;</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160; </div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &lt;ESP8266WiFi.h&gt;</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &quot;Adafruit_MQTT.h&quot;</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &quot;Adafruit_MQTT_Client.h&quot;</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160; </div>
<div class="line"><a name="l00027"></a><span class="lineno"><a class="line" href="class_viz_block.html">   27</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_viz_block.html">VizBlock</a></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;{</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    <span class="keywordtype">char</span>* _ssid;</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    <span class="keywordtype">char</span>* _wifi_pass;</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <span class="keywordtype">char</span>* _id;</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <span class="keywordtype">char</span>* _server;</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    <span class="keywordtype">int</span> _port;</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    <span class="keywordtype">char</span>* _mqtt_user;</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="keywordtype">char</span>* _mqtt_pass;</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="keyword">const</span> <span class="keywordtype">char</span>* _fingerprint;</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160; </div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> NUM_BACKGROUND_BEHAVIOURS = 5;</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    <a class="code" href="class_behaviour_table.html">BehaviourTable</a> _behaviours;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <a class="code" href="class_behaviour.html">Behaviour</a>* _active = <span class="keyword">nullptr</span>;</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <a class="code" href="class_behaviour.html">Behaviour</a>* _background[NUM_BACKGROUND_BEHAVIOURS];</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160; </div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    <span class="keywordtype">int</span> _loop_time = 5;</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> _wifi_timeout; <span class="comment">// How long to wait for wifi until we go into deep sleep</span></div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> _wifi_timeout_initialMillis;</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    <span class="keywordtype">int</span> _ledState = LOW;</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> _previous_flashMillis = 0;</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <span class="keyword">const</span> <span class="keywordtype">long</span> _flash_interval = 1000; <span class="comment">// flash every second when wifi and MQTT are connected</span></div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160; </div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160; </div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    Adafruit_MQTT_Client* _mqtt;</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    Adafruit_MQTT_Subscribe* _device_subscription;</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    Adafruit_MQTT_Publish* _announce;</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    Adafruit_MQTT_Publish* _my_announce;</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    String _my_announce_channel;</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    Adafruit_MQTT_Publish* _input;</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    Adafruit_MQTT_Publish* _my_input;</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    String _my_input_channel;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    WiFiClient* _client;</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    WiFiClientSecure* _client_secure;</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160; </div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    <span class="keywordtype">boolean</span> _wifi;</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160; </div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    String capabilitiesJSON[50];</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160; </div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00067"></a><span class="lineno"><a class="line" href="class_viz_block.html#ad9b3946753b985ec0604b0e2f83b0140">   67</a></span>&#160;    <a class="code" href="class_viz_block.html#ad9b3946753b985ec0604b0e2f83b0140">VizBlock</a>(<span class="keywordtype">char</span>* <span class="keywordtype">id</span>, <span class="keywordtype">char</span>* ssid=<span class="stringliteral">&quot;VizBlockNet&quot;</span>, <span class="keywordtype">char</span>* wifi_pass=<span class="stringliteral">&quot;VizBlocksAP&quot;</span>,</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;              <span class="keywordtype">char</span>* server=<span class="stringliteral">&quot;192.168.4.1&quot;</span>, <span class="keywordtype">int</span> port=1883, <span class="keywordtype">char</span>* mqtt_user=<span class="stringliteral">&quot;&quot;</span>, <span class="keywordtype">char</span>* mqtt_pass=<span class="stringliteral">&quot;&quot;</span>, <span class="keyword">const</span> <span class="keywordtype">char</span>* fingerprint=<span class="stringliteral">&quot;&quot;</span>);</div>
<div class="line"><a name="l00072"></a><span class="lineno"><a class="line" href="class_viz_block.html#a3471cc56f191c186d5905f05f7aae7b3">   72</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_viz_block.html#a3471cc56f191c186d5905f05f7aae7b3">set_wifi</a>(<span class="keywordtype">boolean</span> v);</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160; </div>
<div class="line"><a name="l00077"></a><span class="lineno"><a class="line" href="class_viz_block.html#a6f8002082c1419e9b2718faa75a60356">   77</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_viz_block.html#a6f8002082c1419e9b2718faa75a60356">init</a>();</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160; </div>
<div class="line"><a name="l00082"></a><span class="lineno"><a class="line" href="class_viz_block.html#a05126b273345e8ee4ac3bc0e6bff8da5">   82</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_viz_block.html#a05126b273345e8ee4ac3bc0e6bff8da5">add</a>(<a class="code" href="class_behaviour.html">Behaviour</a> *b);</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160; </div>
<div class="line"><a name="l00089"></a><span class="lineno"><a class="line" href="class_viz_block.html#aa03ed68d6c65b1bcd09e72d59cd789c6">   89</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_viz_block.html#aa03ed68d6c65b1bcd09e72d59cd789c6">run</a>();</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160; </div>
<div class="line"><a name="l00094"></a><span class="lineno"><a class="line" href="class_viz_block.html#a315eb849f9bf9932f90bb26a56b9eec4">   94</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_viz_block.html#a315eb849f9bf9932f90bb26a56b9eec4">serial_command</a>();</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160; </div>
<div class="line"><a name="l00100"></a><span class="lineno"><a class="line" href="class_viz_block.html#a5f43b604ccbee394091bcedfc3e4dc8c">  100</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_viz_block.html#a5f43b604ccbee394091bcedfc3e4dc8c">mqtt_command</a>();</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160; </div>
<div class="line"><a name="l00107"></a><span class="lineno"><a class="line" href="class_viz_block.html#a94c00ec7eea6ce431eaad82b3a82dcdf">  107</a></span>&#160;    String <a class="code" href="class_viz_block.html#a94c00ec7eea6ce431eaad82b3a82dcdf">process</a>(String input);</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160; </div>
<div class="line"><a name="l00114"></a><span class="lineno"><a class="line" href="class_viz_block.html#a2a4006637716e54f202711f633641b43">  114</a></span>&#160;    String <a class="code" href="class_viz_block.html#a2a4006637716e54f202711f633641b43">process_command</a>(String command, String args);</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160; </div>
<div class="line"><a name="l00119"></a><span class="lineno"><a class="line" href="class_viz_block.html#aac8647bb59c5ecf635b4e7349d03a100">  119</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_viz_block.html#aac8647bb59c5ecf635b4e7349d03a100">MQTT_connect</a>();</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160; </div>
<div class="line"><a name="l00124"></a><span class="lineno"><a class="line" href="class_viz_block.html#a2453fafc9ff3dbcb4fa30b3fb66ee600">  124</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_viz_block.html#a2453fafc9ff3dbcb4fa30b3fb66ee600">wifi_connect</a>();</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160; </div>
<div class="line"><a name="l00130"></a><span class="lineno"><a class="line" href="class_viz_block.html#a8842678420f4f04a298ccb01aebb8c5e">  130</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_viz_block.html#a8842678420f4f04a298ccb01aebb8c5e">generateCapabilitiesJSON</a>();</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160; </div>
<div class="line"><a name="l00135"></a><span class="lineno"><a class="line" href="class_viz_block.html#a12ed8ff980180d9c952733f42c1b0748">  135</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_viz_block.html#a12ed8ff980180d9c952733f42c1b0748">announce</a>(String doc);</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160; </div>
<div class="line"><a name="l00140"></a><span class="lineno"><a class="line" href="class_viz_block.html#a469ac7b36030935ea677d4b2385fd4a2">  140</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_viz_block.html#a469ac7b36030935ea677d4b2385fd4a2">announce_capabilities</a>();</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160; </div>
<div class="line"><a name="l00145"></a><span class="lineno"><a class="line" href="class_viz_block.html#ae187beaf64d567c93ba5775b252259ee">  145</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_viz_block.html#ae187beaf64d567c93ba5775b252259ee">setID</a>(<span class="keywordtype">char</span>* <span class="keywordtype">id</span>);</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160; </div>
<div class="line"><a name="l00150"></a><span class="lineno"><a class="line" href="class_viz_block.html#a681ab4c036640a3cea3941aa9e2e1ca6">  150</a></span>&#160;    <span class="keywordtype">char</span>* <a class="code" href="class_viz_block.html#a681ab4c036640a3cea3941aa9e2e1ca6">getId</a>();</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160; </div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;};</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160; </div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;<span class="comment">/*</span></div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;<span class="comment"> * These behaviours depend on VizBlock class so they must be included after</span></div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;<span class="comment"> * it has been defined.</span></div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;<span class="comment"> */</span></div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_comms_behaviours_8h.html">CommsBehaviours.h</a>&quot;</span></div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_button_behaviours_8h.html">ButtonBehaviours.h</a>&quot;</span></div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_potentiometer_behaviours_8h.html">PotentiometerBehaviours.h</a>&quot;</span></div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_rotary_encoder_behaviours_8h.html">RotaryEncoderBehaviours.h</a>&quot;</span></div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160; </div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="ttc" id="a_behaviours_8h_html"><div class="ttname"><a href="_behaviours_8h.html">Behaviours.h</a></div><div class="ttdoc">Functionality for block behaviours.</div></div>
<div class="ttc" id="a_button_behaviours_8h_html"><div class="ttname"><a href="_button_behaviours_8h.html">ButtonBehaviours.h</a></div><div class="ttdoc">Behaviours to communicate button events to a server via mqtt. A lot of these input behaviours are qui...</div></div>
<div class="ttc" id="a_comms_behaviours_8h_html"><div class="ttname"><a href="_comms_behaviours_8h.html">CommsBehaviours.h</a></div><div class="ttdoc">Behaviours that send useful information to a server or other blocks. These are a bit weird and experi...</div></div>
<div class="ttc" id="a_l_e_d_behaviours_8h_html"><div class="ttname"><a href="_l_e_d_behaviours_8h.html">LEDBehaviours.h</a></div><div class="ttdoc">Behaviours to control a neopixel ring. This should be extended with stable behaviours that are develo...</div></div>
<div class="ttc" id="a_name_dictionary_8h_html"><div class="ttname"><a href="_name_dictionary_8h.html">NameDictionary.h</a></div><div class="ttdoc">Block auto naming functionality.</div></div>
<div class="ttc" id="a_potentiometer_behaviours_8h_html"><div class="ttname"><a href="_potentiometer_behaviours_8h.html">PotentiometerBehaviours.h</a></div><div class="ttdoc">Behaviours to communicate potentiometer events to a server via mqtt. A lot of these input behaviours ...</div></div>
<div class="ttc" id="a_rotary_encoder_behaviours_8h_html"><div class="ttname"><a href="_rotary_encoder_behaviours_8h.html">RotaryEncoderBehaviours.h</a></div><div class="ttdoc">Behaviours to communicate rotary encoder events to a server via mqtt. A lot of these input behaviours...</div></div>
<div class="ttc" id="a_servo_behaviours_8h_html"><div class="ttname"><a href="_servo_behaviours_8h.html">ServoBehaviours.h</a></div><div class="ttdoc">Behaviours to control a servo motor. This should be extended with stable behaviours that are develope...</div></div>
<div class="ttc" id="aclass_behaviour_html"><div class="ttname"><a href="class_behaviour.html">Behaviour</a></div><div class="ttdoc">Parent class for all other behaviours.</div><div class="ttdef"><b>Definition:</b> Behaviours.h:20</div></div>
<div class="ttc" id="aclass_behaviour_table_html"><div class="ttname"><a href="class_behaviour_table.html">BehaviourTable</a></div><div class="ttdoc">A container for a block's behaviours.</div><div class="ttdef"><b>Definition:</b> Behaviours.h:89</div></div>
<div class="ttc" id="aclass_viz_block_html"><div class="ttname"><a href="class_viz_block.html">VizBlock</a></div><div class="ttdoc">The main VizBlock class.</div><div class="ttdef"><b>Definition:</b> VizBlocks.h:28</div></div>
<div class="ttc" id="aclass_viz_block_html_a05126b273345e8ee4ac3bc0e6bff8da5"><div class="ttname"><a href="class_viz_block.html#a05126b273345e8ee4ac3bc0e6bff8da5">VizBlock::add</a></div><div class="ttdeci">void add(Behaviour *b)</div></div>
<div class="ttc" id="aclass_viz_block_html_a12ed8ff980180d9c952733f42c1b0748"><div class="ttname"><a href="class_viz_block.html#a12ed8ff980180d9c952733f42c1b0748">VizBlock::announce</a></div><div class="ttdeci">void announce(String doc)</div></div>
<div class="ttc" id="aclass_viz_block_html_a2453fafc9ff3dbcb4fa30b3fb66ee600"><div class="ttname"><a href="class_viz_block.html#a2453fafc9ff3dbcb4fa30b3fb66ee600">VizBlock::wifi_connect</a></div><div class="ttdeci">void wifi_connect()</div></div>
<div class="ttc" id="aclass_viz_block_html_a2a4006637716e54f202711f633641b43"><div class="ttname"><a href="class_viz_block.html#a2a4006637716e54f202711f633641b43">VizBlock::process_command</a></div><div class="ttdeci">String process_command(String command, String args)</div></div>
<div class="ttc" id="aclass_viz_block_html_a315eb849f9bf9932f90bb26a56b9eec4"><div class="ttname"><a href="class_viz_block.html#a315eb849f9bf9932f90bb26a56b9eec4">VizBlock::serial_command</a></div><div class="ttdeci">void serial_command()</div></div>
<div class="ttc" id="aclass_viz_block_html_a3471cc56f191c186d5905f05f7aae7b3"><div class="ttname"><a href="class_viz_block.html#a3471cc56f191c186d5905f05f7aae7b3">VizBlock::set_wifi</a></div><div class="ttdeci">void set_wifi(boolean v)</div></div>
<div class="ttc" id="aclass_viz_block_html_a469ac7b36030935ea677d4b2385fd4a2"><div class="ttname"><a href="class_viz_block.html#a469ac7b36030935ea677d4b2385fd4a2">VizBlock::announce_capabilities</a></div><div class="ttdeci">void announce_capabilities()</div></div>
<div class="ttc" id="aclass_viz_block_html_a5f43b604ccbee394091bcedfc3e4dc8c"><div class="ttname"><a href="class_viz_block.html#a5f43b604ccbee394091bcedfc3e4dc8c">VizBlock::mqtt_command</a></div><div class="ttdeci">void mqtt_command()</div></div>
<div class="ttc" id="aclass_viz_block_html_a681ab4c036640a3cea3941aa9e2e1ca6"><div class="ttname"><a href="class_viz_block.html#a681ab4c036640a3cea3941aa9e2e1ca6">VizBlock::getId</a></div><div class="ttdeci">char * getId()</div></div>
<div class="ttc" id="aclass_viz_block_html_a6f8002082c1419e9b2718faa75a60356"><div class="ttname"><a href="class_viz_block.html#a6f8002082c1419e9b2718faa75a60356">VizBlock::init</a></div><div class="ttdeci">void init()</div></div>
<div class="ttc" id="aclass_viz_block_html_a8842678420f4f04a298ccb01aebb8c5e"><div class="ttname"><a href="class_viz_block.html#a8842678420f4f04a298ccb01aebb8c5e">VizBlock::generateCapabilitiesJSON</a></div><div class="ttdeci">void generateCapabilitiesJSON()</div></div>
<div class="ttc" id="aclass_viz_block_html_a94c00ec7eea6ce431eaad82b3a82dcdf"><div class="ttname"><a href="class_viz_block.html#a94c00ec7eea6ce431eaad82b3a82dcdf">VizBlock::process</a></div><div class="ttdeci">String process(String input)</div></div>
<div class="ttc" id="aclass_viz_block_html_aa03ed68d6c65b1bcd09e72d59cd789c6"><div class="ttname"><a href="class_viz_block.html#aa03ed68d6c65b1bcd09e72d59cd789c6">VizBlock::run</a></div><div class="ttdeci">void run()</div></div>
<div class="ttc" id="aclass_viz_block_html_aac8647bb59c5ecf635b4e7349d03a100"><div class="ttname"><a href="class_viz_block.html#aac8647bb59c5ecf635b4e7349d03a100">VizBlock::MQTT_connect</a></div><div class="ttdeci">void MQTT_connect()</div></div>
<div class="ttc" id="aclass_viz_block_html_ad9b3946753b985ec0604b0e2f83b0140"><div class="ttname"><a href="class_viz_block.html#ad9b3946753b985ec0604b0e2f83b0140">VizBlock::VizBlock</a></div><div class="ttdeci">VizBlock(char *id, char *ssid=&quot;VizBlockNet&quot;, char *wifi_pass=&quot;VizBlocksAP&quot;, char *server=&quot;192.168.4.1&quot;, int port=1883, char *mqtt_user=&quot;&quot;, char *mqtt_pass=&quot;&quot;, const char *fingerprint=&quot;&quot;)</div></div>
<div class="ttc" id="aclass_viz_block_html_ae187beaf64d567c93ba5775b252259ee"><div class="ttname"><a href="class_viz_block.html#ae187beaf64d567c93ba5775b252259ee">VizBlock::setID</a></div><div class="ttdeci">void setID(char *id)</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- HTML footer for doxygen 1.8.18-->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.9.1
</small></address>
</body>
</html>
